Index: /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/ViewModels/User/UserViewModel.cs
===================================================================
--- /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/ViewModels/User/UserViewModel.cs	(revision 13804)
+++ /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/ViewModels/User/UserViewModel.cs	(revision 13805)
@@ -7,4 +7,7 @@
 namespace HeuristicLab.Clients.Hive.WebJobManager.ViewModels.User
 {
+    /// <summary>
+    /// ViewModel containing User/Group/Role data
+    /// </summary>
     public class UserViewModel
     {
@@ -24,4 +27,8 @@
         public List<Access.UserGroupBase> SelectedRoleEnrolled { get; set; }
 
+        /// <summary>
+        /// Initialize viewmodel and set up connection
+        /// </summary>
+        /// <param name="ac">AccessAdminClient for connection</param>
         public UserViewModel(AccessAdministrationClient ac)
         {
@@ -40,4 +47,8 @@
             
         }
+        /// <summary>
+        /// Refreshes Users, Groups and Roles
+        /// </summary>
+        /// <returns></returns>
         public UserViewModel refreshAll()
         {
@@ -47,4 +58,8 @@
             return this;
         }
+        /// <summary>
+        /// Refreshes only the Users
+        /// </summary>
+        /// <returns></returns>
         public UserViewModel refreshUsers()
         {
@@ -53,4 +68,8 @@
             return this;
         }
+        /// <summary>
+        /// Refreshes only the Roles
+        /// </summary>
+        /// <returns></returns>
         public UserViewModel refreshRoles()
         {
@@ -59,4 +78,8 @@
             return this;
         }
+        /// <summary>
+        /// Refreshes only the User Groups
+        /// </summary>
+        /// <returns></returns>
         public UserViewModel refreshGroups()
         {
@@ -65,12 +88,27 @@
             return this;
         }
+        /// <summary>
+        /// Returns a user by its Id
+        /// </summary>
+        /// <param name="id">User Id</param>
+        /// <returns></returns>
         public Access.User getUserById(Guid id)
         {
             return users.Find(x => x.Id == id);
         }
+        /// <summary>
+        /// Returns a group by its Id
+        /// </summary>
+        /// <param name="id">Group id</param>
+        /// <returns></returns>
         public Access.UserGroup getGroupById(Guid id)
         {
             return ugroups.Find(x => x.Id == id);
         }
+        /// <summary>
+        /// Returns a role by its name
+        /// </summary>
+        /// <param name="name">Role name</param>
+        /// <returns></returns>
         public Access.Role getRoleByName(string name)
         {
Index: /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Resource/Index.cshtml
===================================================================
--- /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Resource/Index.cshtml	(revision 13804)
+++ /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Resource/Index.cshtml	(revision 13805)
@@ -8,5 +8,5 @@
 
     <div class="col-sm-4">
-        <div class="btn-group btn-group-justified" style="padding:3px;margin-bottom:-10px"
+        <div class="btn-group btn-group-justified" style="padding:3px;margin-bottom:-12px"
              role="group">
             <a class="btn btn-info btn-lg btn-block disabled"
@@ -48,33 +48,90 @@
             </h3>
             <ul class="nav nav-pills nav-justified">
-                <li role="presentation" ng-class="{ 'active': !permission }" ng-style="{ 'text-decoration': !permission ? 'underline' : ''}">
+                <li role="presentation"
+                    ng-class="{ 'active': !permissionview && !resaddview }"
+                    ng-style="{ 'text-decoration': !permissionview && !resaddview ? 'underline' : ''}">
                     <a style="text-shadow:2px 2px black; color:white; font-weight:bold; border: 1px solid white;"
                        href=""
-                       ng-click="permission = false">
+                       ng-click="menuchange(0)">
                         Resource info
                     </a>
                 </li>
-                <li role="presentation" ng-class="{ 'active': permission }" ng-style="{ 'text-decoration': permission ? 'underline' : ''}">
+                <li role="presentation"
+                    ng-class="{ 'active': permissionview }"
+                    ng-style="{ 'text-decoration': permissionview ? 'underline' : ''}">
                     <a style="text-shadow:2px 2px black; color:white; font-weight:bold; border: 1px solid white;"
                        href=""
-                       ng-click="permission = true">
+                       ng-click="menuchange(1)">
                         Permissions
                     </a>
                 </li>
+                <li ng-if="treeview.currentNode.IsDisposable === undefined"
+                    role="presentation"
+                    ng-class="{ 'active': resaddview }"
+                    ng-style="{ 'text-decoration': resaddview ? 'underline' : ''}">
+
+                    <a style="text-shadow:2px 2px black; color:white; font-weight:bold; border: 1px solid white;"
+                       href=""
+                       ng-click="menuchange(2)">
+                        Add resources
+                    </a>
+                </li>
             </ul>
-            
-            <form ng-show="permission"
+            <form ng-show="!permissionview && resaddview"
                   method="post"
-                  asp-action="editPermissions"
+                  asp-action="addResourcesToGroup"
                   asp-controller="Resource"
                   enctype="multipart/form-data"
-                  class="row panel-heading"
-                  > 
-                <div
-                     class="row" style="padding:10px;">
+                  class="row panel-heading">
+                <div class="row" style="padding:5px;">
+                    <h4>Info</h4>
+                    <p>
+                        This shows only
+                        <span style="text-decoration:underline">direct members</span>
+                        of the group (not members of subgroups).
+                    </p>
+                    <p>Adding a member will overwrite the current group it's a member in (if any)</p>
+                    <p>Removing an existing member will make it revert to Ungrouped.</p>
+                    <a ng-click="refreshAdds()" href=""
+                       class="btn btn-info pull-right"
+                       style="box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
+                            text-shadow:2px 2px black;">Reset to current members</a>
+                    <div class="row" style="margin:5px">
+                        <h4>All resources</h4>
+                        <label class="col-sm-3"
+                               ng-style="{
+                                   'background-color':client.add === true ? 'green' : '' }"
+                               ng-repeat="client in clients  | orderBy:['!add', 'Name' ]  | filter:searchText">
+                            <input type="checkbox"
+                                   name="addres"
+                                   value="{{client.Id}}"
+                                   ng-model="client.add"> {{client.Name}}
+                        </label>
+                    </div>
+                </div>
+                <input style="display:none"
+                       type="text"
+                       id="groupid"
+                       name="groupid"
+                       value="{{treeview.currentNode.Id}}" />
+
+                <button type="submit"
+                        id="inpsaver"
+                        class="btn btn-success pull-right"
+                        style="box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
+                            text-shadow:2px 2px black;">
+                    <i class="fa fa-save"></i>
+                    Add resources to group
+                </button>
+            </form>
+            <form ng-show="permissionview && !resaddview"
+                  method="post"
+                  enctype="multipart/form-data"
+                  class="row panel-heading">
+                <div class="row" style="padding:10px;">
                     <h4>Groups</h4>
                     <label class="col-sm-3" ng-repeat="group in permGroups">
-                        <input type="checkbox" 
-                               name="permgroups" 
+                        <input type="checkbox"
+                               name="permgroups"
                                value="{{group.Id}}"
                                ng-model="group.state"> {{group.Name}}
@@ -84,18 +141,19 @@
                     <h4>Users</h4>
                     <label class="col-sm-3 col-lg-2" ng-repeat="user in permUsers">
-                        <input type="checkbox" 
-                               name="permusers" 
+                        <input type="checkbox"
+                               name="permusers"
                                value="{{user.Id}}"
                                ng-model="user.state"> {{user.UserName}}
                     </label>
                 </div>
-                <div class="btn btn-info pull-right" 
+                <div class="btn btn-success pull-right"
                      style="box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
                             text-shadow:2px 2px black;"
                      ng-click="pushPermissions()">
-                <i ng-if="permissionLoader" class="fa fa-spin fa-save"></i> 
-                Save permission changes</div>
+                    <i ng-if="permissionLoader" class="fa fa-spin fa-save"></i>
+                    Save permission changes
+                </div>
             </form>
-            <form ng-show="!permission"
+            <form ng-show="!permissionview && !resaddview"
                   method="post"
                   asp-action="deleteClientGroup"
@@ -155,5 +213,5 @@
                         <tr>
                             <td>Memory (free/total)</td>
-                            <td>{{treeview.currentNode.FreeMemory/1024 | number:1}} GB / {{treeview.currentNode.Memory/1024 | number:1}} GB</td>
+                            <td>{{treeview.currentNode.FreeMemory/1024 | number:1}} / {{treeview.currentNode.Memory/1024 | number:1}} GB</td>
                         </tr>
 
@@ -161,5 +219,5 @@
                 </table>
             </form>
-            <form method="post"
+            <form method="post" ng-show="!permissionview && !resaddview"
                   asp-action="changeParent"
                   asp-controller="Resource"
@@ -169,5 +227,5 @@
                 <input style="display:none" type="text" id="inpid" name="inpid" value="{{treeview.currentNode.Id}}" />
 
-                <span style="padding:0px" class="col-sm-4">Change parent resource: </span>
+                <span style="padding:0px" class="col-sm-4">Change group: </span>
 
                 <select class="form-control col-sm-5"
@@ -190,5 +248,5 @@
                             text-shadow:2px 2px black;">
                     <i class="fa fa-save"></i>
-                    Change parent
+                    Change group
                 </button>
             </form>
@@ -485,16 +543,22 @@
                 <h3>Choose resources </h3>
                 <h5>(This will overwrite the group set for these resources)</h5>
-                <table>
-                    <tr ng-repeat="client in clients  | orderBy:['Name'] track by $index" class="checkbox col-md-6 col-lg-4">
-                        <td>
-                            <label>
-                                <input type="checkbox"
-                                       name="clientstoadd"
-                                       value="{{client.Id}}">
-                                <i class="fa fa-desktop" aria-hidden="true"></i> {{client.Name | limitTo : 7}} - {{client.Cores}}x {{client.CpuSpeed/1000 |  number:1}} GHz - {{client.Memory / 1024 | number:1}} GB
-                            </label>
-                        </td>
-                    </tr>
-                </table>
+                <label>Search: <input ng-init="searchText = ''" ng-model="searchText"></label>
+                <div class="row">
+                    <div style="margin:0px"
+                         ng-repeat="client in clients  | orderBy:['Name']  | filter:searchText" class="checkbox col-md-6 col-lg-4">
+
+                        <label ng-style="{
+                                   'background-color':client.checked === true ? 'green' : '',
+                                    'color':client.checked === true ? 'white' : ''  }"
+                               style="border-radius:5px">
+                            <input type="checkbox"
+                                   name="clientstoadd"
+                                   ng-model="client.checked"
+                                   value="{{client.Id}}" />
+                            <i class="fa fa-desktop" aria-hidden="true"></i> {{client.Name | limitTo : 7}} - {{client.Cores}}x {{client.CpuSpeed/1000 |  number:1}} GHz - {{client.Memory / 1024 | number:1}} GB
+                        </label>
+
+                    </div>
+                </div>
             </div>
         </form>
Index: /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/User/Groups.cshtml
===================================================================
--- /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/User/Groups.cshtml	(revision 13804)
+++ /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/User/Groups.cshtml	(revision 13805)
@@ -37,7 +37,9 @@
          style="padding:10px; margin-right:0px!important">
         <div class="col-sm-4">
-            <div class="btn-group-vertical btn-block">
+            <div class="btn-group btn-group-justified btn-block"
+                 role="group" style="margin-bottom:-4px">
+
                 <a class="btn btn-info btn-lg btn-block disabled"
-                   style="box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
+                   style="width:6%;box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
                             text-shadow:2px 2px black;">
                     <i class="fa fa-group"></i> @Model.ugroups.Count Group@(Model.ugroups.Count != 1 ? "s" : "")
@@ -52,6 +54,9 @@
                    style="box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
                             text-shadow:2px 2px black;">
-                    <i class="fa fa-plus-circle"></i> Add new group
+                    <i class="fa fa-plus-circle"></i> 
                 </a>
+            </div>
+            <div class="btn-group-vertical btn-block">
+                
                 @foreach (var group in Model.ugroups)
                 {
@@ -128,5 +133,9 @@
                                 </div>
                             </div>
-
+                            <input type="text"
+                                   style="display:none"
+                                   id="u"
+                                   name="u"
+                                   value="@Model.SelectedGroup.Id" />
 
                             @if (Model.SelectedGroup.Id != Guid.Empty)
Index: /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/User/Index.cshtml
===================================================================
--- /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/User/Index.cshtml	(revision 13804)
+++ /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/User/Index.cshtml	(revision 13805)
@@ -47,21 +47,27 @@
         {
             <div class="col-sm-4">
-                <div class="btn-group-vertical btn-block">
-                    <a class="btn btn-info btn-lg btn-block disabled"
-                       style="box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
+                <div class="btn-group btn-group-justified btn-block"
+                     role="group" style="margin-bottom:-4px">
+
+                    <a class="btn btn-info btn-lg disabled"
+                       style="width:6%;box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
                             text-shadow:2px 2px black;">
                         <i class="fa fa-user"></i> @Model.users.Count User@(Model.users.Count != 1 ? "s" : "")
                     </a>
-                    <a class="btn btn-success btn-block
+                    <a class="btn btn-success
                        @(Model.SelectedUser.Id == Guid.Empty ? "active" : "")
                        "
+                       style="box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
+                            text-shadow:2px 2px black;"
                        asp-controller="User"
                        asp-action="SelectUser"
                        asp-route-id="@Guid.Empty"
-                       onclick="showUser()"
-                       style="box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
-                            text-shadow:2px 2px black;">
-                        <i class="fa fa-user-plus"></i> Add new user
+                       onclick="showUser()">
+                        <i class="fa fa-user-plus"></i>
                     </a>
+                </div>
+                <div class="btn-group-vertical btn-block">
+                    
+                    
                     @foreach (var user in Model.users)
                     {
@@ -119,5 +125,5 @@
                               method="post"
                               asp-action="saveUser"
-                              asp-controller="User" 
+                              asp-controller="User"
                               enctype="multipart/form-data"
                               onsubmit="showSaver()">
@@ -181,5 +187,5 @@
                                         @Model.SelectedUser.Id
                                     </label>
-                                    
+
                                 </div>
                                 <div class="form-group">
@@ -295,5 +301,5 @@
                                             {
                                                 <div class="row">
-                                                    
+
                                                     <p class="col-sm-10"><i class="fa fa-gavel"></i> @r.Name</p>
                                                     <p class="col-sm-2">
@@ -359,6 +365,5 @@
                                             id="inpsaver"
                                             disabled
-                                            class="btn btn-default"
-                                            >
+                                            class="btn btn-default">
                                         <i class="fa fa-save"></i>
                                         @(Model.SelectedUser.Id != Guid.Empty ? "Save changes" : "Add user")
Index: /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/User/Roles.cshtml
===================================================================
--- /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/User/Roles.cshtml	(revision 13804)
+++ /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/User/Roles.cshtml	(revision 13805)
@@ -38,7 +38,9 @@
 
         <div class="col-sm-4">
-            <div class="btn-group-vertical btn-block">
+            <div class="btn-group btn-group-justified btn-block"
+                 role="group" style="margin-bottom:-4px">
+
                 <a class="btn btn-info btn-lg btn-block disabled"
-                   style="box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
+                   style="width:6%;box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
                             text-shadow:2px 2px black;">
                     <i class="fa fa-gavel"></i> @Model.roles.Count Role@(Model.roles.Count != 1 ? "s" : "")
@@ -53,6 +55,9 @@
                    style="box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
                             text-shadow:2px 2px black;">
-                    <i class="fa fa-plus-circle"></i> Add new role
+                    <i class="fa fa-plus-circle"></i>
                 </a>
+            </div>
+            <div class="btn-group-vertical btn-block">
+                
                 @foreach (var role in Model.roles)
                 {
Index: /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/wwwroot/js/hubs/calendarhubber.js
===================================================================
--- /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/wwwroot/js/hubs/calendarhubber.js	(revision 13804)
+++ /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/wwwroot/js/hubs/calendarhubber.js	(revision 13805)
@@ -14,5 +14,6 @@
                vm.alertMessage = "No alerts";
                vm.currentcal = [];
-               $scope.permission = false;
+               $scope.permissionview = false;
+               $scope.resaddview = false;
                vm.selectedEventId = -1;
                vm.groups = [];
@@ -100,4 +101,5 @@
                    $scope.$watch("treeview.currentNode", function (newValue, oldValue) {
                        $scope.currentcal = [];
+                       $scope.resaddview = false;
                        $(".selected.ng-binding").addClass('loaded');
                        $scope.selectedEventId = -1;
@@ -112,11 +114,22 @@
                                $timeout(function () {
                                    refreshPermissions();
+                                   
                                    $scope.currentcal = $scope.treeview.currentNode.calendar;
                                }, 0);
 
                            }
-                       }
-
-                   });
+                           $scope.refreshAdds();
+                       }
+
+                   });
+               }
+               $scope.refreshAdds = function() {
+                   for (var i = 0; i < $scope.clients.length; i++) {
+                       $scope.clients[i].add = false;
+                       for (var j = 0; j < $scope.treeview.currentNode.children.length; j++) {
+                           if ($scope.clients[i].Id === $scope.treeview.currentNode.children[j].Id)
+                               $scope.clients[i].add = true;
+                       }
+                   }
                }
                function refreshPermissions() {
@@ -650,4 +663,21 @@
                };
 
+               $scope.menuchange = function (i) {
+                   switch(i) {
+                       case 0:
+                           $scope.permissionview = false;
+                           $scope.resaddview = false;
+                           break;
+                       case 1:
+                           $scope.permissionview = true;
+                           $scope.resaddview = false;
+                           break;
+                       case 2:
+                           $scope.permissionview = false;
+                           $scope.resaddview = true;
+                           break;
+                   }
+               }
+
 
 
Index: /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/wwwroot/js/hubs/userinfohubber.js
===================================================================
--- /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/wwwroot/js/hubs/userinfohubber.js	(revision 13804)
+++ /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/wwwroot/js/hubs/userinfohubber.js	(revision 13805)
@@ -1,1 +1,1 @@
-function resetPass(a){hubber.server.resetPassword(a)}var hubber=$.connection.userInfoHub;$(function(){$.connection.hub.logging=!0;var a=document.getElementById("userId").innerHTML;console.log(a),$.connection.hub.qs={userid:a},$.connection.hub.start(),hubber.client.showNewPass=function(a){$("#inppassreset").html("<label class=' control-label' style='text-align:left'>New password: "+a+"</label>")}});
+function resetPass(a){hubber.server.resetPassword(a)}var hubber=$.connection.userInfoHub;$(function(){var a=document.getElementById("userId").innerHTML;console.log(a),$.connection.hub.qs={userid:a},$.connection.hub.start(),hubber.client.showNewPass=function(a){$("#inppassreset").html("<label class=' control-label' style='text-align:left'>An email has been sent to the user containing the new password</label>")}});
